/*

file: hw3.java

Written by Ahmet Uyar and Gurhan Gunduz

Solution for this problem is:

chromSize*(48+24+12)= 32*84 = 2688

*/

public class project{
	public static void main(String args[]){
      PackagePack pp = new PackagePack();
      int sum = 0;
//      for(int i=0; i<10; i++)
		sum += pp.begin();
//   	System.out.println("Average: "+ sum/10);

   }
}

class PackagePack{
   boolean pop[][][];
   boolean lastBest[][], currentBest[][];
   int fitness[];
   int profits[];
   int packageSizes[];
   int truckSizes[] = {6, 12, 17, 4, 15, 10, 8, 3, 6, 19};
   final int popSize = 10, numberOfPackages = 50, numberOfTrucks = 10, maxPackageSize = 10, maxTruckSize = 20;
   int maxProfit = 15, totalProfit;
   double crossRate = 0.8, mutationRate = 0.2, survivorRate = 0.2;

   public int begin(){
      pop = new boolean[popSize][numberOfTrucks + 1][numberOfPackages];
      lastBest= new boolean[numberOfTrucks + 1][numberOfPackages];
      currentBest=new boolean[numberOfTrucks + 1][numberOfPackages];
      profits = new int[numberOfPackages];
      packageSizes = new int[numberOfPackages];
//      truckSizes = new int[numberOfTrucks];
      fitness= new int[popSize];

      initialize();
      evaluateFitness();
      System.out.print("\nfitness: ");
      display(fitness);
      findTheBest();
      int genNumber = 0;
      while(genNumber<10)
		{
//			assignArray(lastBest, currentBest);
//	     	select();
//		   crossOver();
//	    	mutate();
//         display();
//	    	findTheBest();
//	    	keepTheBest();
	    	localImprovement();
	    	evaluateFitness();
	      System.out.print("\nfitness: ");
	      display(fitness);
//	   	System.out.println("\ngeneration: "+genNumber+"  best fitness..: " + evaluateOneChrom(currentBest));
//	   	System.out.println(evaluateOneChrom(currentBest));
	    	genNumber++;

      }//end of while
//      System.out.print("\nPackage Sizes: ");
//      display(packageSizes);
//      System.out.print("\nprofits: ");
//      display(profits);
      System.out.print("\ncurrent best: "+evaluateOneMatrix(currentBest));
//      display();
//      System.out.println("truck sizes: ");
//      display(truckSizes);

//      display();

//      evaluateFitness();
	return 0;
  }//end of begin


  public void initialize(){

	//initialize packages
	for(int i=0; i<packageSizes.length; i++)
		packageSizes[i] = i % (maxPackageSize-1) + 1;

	totalProfit=0;
	for(int i=0; i< profits.length; i++)
		totalProfit += profits[i] = (2*i) % maxProfit;

System.out.println("totalProfit: "+totalProfit);

	//initialize the extras to all true
	for(int i=0; i< pop.length; i++)
		for(int j=0; j< pop[i][numberOfTrucks].length; j++)
			pop[i][numberOfTrucks][j] = true;

	for(int i=0; i< pop.length; i++)
		initOneMatrix(pop[i]);

  }//end of initialize

  public void initOneMatrix(boolean mat[][]){

	int pool[] = new int[numberOfPackages];
	for(int i=0; i< pool.length; i++)
		pool[i] = i;
	int index, totalSize;
	int poolTop = numberOfPackages;
	for(int i=0; i<mat.length - 1; i++){
		totalSize = 0;
		for(int j=0; j<mat[i].length; j++){
			index = (int)(poolTop * Math.random());
			totalSize += packageSizes[pool[index]];
			if(totalSize <= truckSizes[i]){
				mat[i][pool[index]] = true;
				mat[numberOfTrucks][pool[index]] = false;
				pool[index] = pool[--poolTop];
			}else{
				totalSize -= packageSizes[pool[index]];
			}
		}
	}
  }//end of initOneMatrix


 //replace the worst k chromosome with the best k chromosome
    public void select(){
		int m1, m2;
		int survivorNumber = (int)(survivorRate * popSize);
		int temp[]= new int[popSize];
		assignArray(temp, fitness);
		partialSort(temp, survivorNumber);
		for(int i=0; i<survivorNumber; i++){
			m1 = findIndex( temp[i] );
	    	m2 = replaceWorst( pop[m1] );
			fitness[m2] = fitness[m1];
		}
    }//end of select

    //finds the index number of a chromosome, when fitness value is provided
    public int findIndex(int k){
		for(int i=0; i<fitness.length; i++){
		    if(k == fitness[i])
				return i;
		}
		return 0;
    }//end of findIndex

    //sort first k elements in the array from the biggest
    public void partialSort(int a[], int k){
		int i, j, temp;
		for(i=0; i<k; i++){
	    	for(j=i; j<a.length;j++){
				if(a[i]<a[j]){
		    		temp = a[i];
		    		a[i] = a[j];
		    		a[j] = temp;
				}
	    	}
		}
    }//end of sort

    //replace the worst with the provided one
    public int replaceWorst(boolean a[][]){
		int i, worstIndex=0, min=fitness[0];
		for(i=1; i<fitness.length; i++){
	    	if(min > fitness[i]){
				min = fitness[i];
				worstIndex = i;
	    	}
		}
		assignArray(pop[worstIndex], a);
		return worstIndex;
    }//end of replaceWorst


  public void evaluateFitness(){

	for(int i =0; i<fitness.length; i++)
		fitness[i] = evaluateOneMatrix(pop[i]);
  }//evaluateFitness

  public int evaluateOneMatrix(boolean a[][]){

	int temp = totalProfit;
	for(int i =0; i<a[numberOfTrucks].length; i++)
		if(a[numberOfTrucks][i])
			temp -= profits[i];
	return temp;

  }//evaluateOneMatrix

   //try to find better choices among extra packages.
   public void localImprovement(){

		for(int i=0; i<pop.length; i++)
			improveOneMatrix(pop[i]);

   }//end of localImprovement

   public void improveOneMatrix(boolean a[][]){

		int index;
		for(int i=0; i<a[numberOfTrucks].length; i++){
			if( !a[numberOfTrucks][i] ){
				index = getTruckIndex(a, i);
				improveOneRow(a[index], a[numberOfTrucks], i, index);
			}
		}

   }//end of improveOneMatrix

   public void improveOneRow(boolean a[], boolean extra[], int index, int truckNo){

		for(int i=0; i<extra.length; i++){
			if(extra[i] && (profits[i]>profits[index])&&((getSizes(a)+packageSizes[i]-packageSizes[index])<=truckSizes[truckNo])){
				a[i] = true;
				extra[i] = false;
				a[index] = false;
				extra[index] = true;
				index = i;
			}
		}

   }//end of improveOneRow

   public int getTruckIndex(boolean a[][], int k){

		for(int i=0; i<a.length; i++)
			if(a[i][k]) return i;
		return -1;

   }//end of getTruckIndex()

   public int getSizes(boolean a[]){

		int temp=0;
		for(int i=0; i<a.length; i++)
			if(a[i]) temp+= packageSizes[i];
		return temp;

   }//end of getProfit()

   //find the best chromosome in population and store it in currentBest
   public void findTheBest(){
	   int i, bestIndex=0, max=fitness[0];
	   for(i=1; i<fitness.length; i++){
	      if(max<fitness[i]){
		      max = fitness[i];
		      bestIndex = i;
	      }
	   }
//      System.out.println("Best fitness: "+fitness[bestIndex]);
	   assignArray(currentBest, pop[bestIndex]);
   }//end of findTheBest

  public void keepTheBest(){
	  if(evaluateOneMatrix(lastBest) <= evaluateOneMatrix(currentBest))
	      return;
	  int i, worstIndex=0, min=fitness[0];
	  for(i=1; i<fitness.length; i++){
	    if(min > fitness[i]){
		    min = fitness[i];
		    worstIndex = i;
	    }
     }
	  assignArray(pop[worstIndex], lastBest);
	  assignArray(currentBest, lastBest);
  }

    //assign the second array to the first one
   public static void assignArray(boolean a1[][], boolean a2[][]){
   	if(a1.length != a2.length){
   	    System.out.println("\n\n Arrays are not equal size");
	       return;
   	}
	   for(int i=0; i<a1.length; i++)
         for(int j=0; j<a1[i].length; j++)
            a1[i][j] = a2[i][j];
   }

   //assign the second array to the first one
   public void assignArray(int a1[], int a2[]){
	   if(a1.length != a2.length){
	      System.out.println("\n\n Arrays are not equal size");
	      return;
	   }
	   for(int i=0; i<a1.length; i++)
         a1[i] = a2[i];
      }


  public void display(){

	  for(int i=0; i<pop.length; i++){
		System.out.println("\nmatrix: "+i);
		for(int j=0; j<pop[i].length; j++){
			System.out.println();
			for(int k=0; k<pop[i][j].length; k++){
				if(pop[i][j][k]) System.out.print("1"); else System.out.print("0");
			}
		}
	  }
  }

  public void display(int a[]){

	System.out.println();
	  for(int i=0; i<a.length; i++){
		System.out.print(a[i]+" ");
	  }
  }

}//end of PackagePack

